% function [A, phi]=calcAphi(x, Z) 
%
% calculates amplitudes A and frequencies phi of x,
% such that (dft(x))[k+1] = A[k+1] exp(i phi[k+1])
% where the signal x is zero-padded with Z zeros
% Z should be even
%
% copyright (C) 2005 Bert Greevenbosch

function [A, phi]=calcAphi(x, Z) 
   
   Zh=Z/2;
   N=length(x); 
   y=fft(fftshift([zeros(1, Zh), x, zeros(1, Zh)]));   
   y=y(1:(N+Z)/2+1);
   A=abs(y);
   phi=princarg(angle(y));   
