% function f=detfreq(x)
%
% determines the main frequency f of the signal x
% returns frequency in Hz (when x sampled at a rate of 44100 Hz)
%
% copyright (C) 2005 Bert Greevenbosch

function f=detfreq(x);

   N=length(x);
   window=sin((0:N-1)*pi/N)'.^2;
   
   y=abs(fft(x(1:N).*window));
   y(1)=0;
   [mx, idx]=max(y);
   if(mx>.001*N)
     f=44100*(idx-1)/N;
   else
     f=0;
   end
