% function [y1, y2]=filterclar(x, w)
%
% clarinet filter
%
% input:
%
% x  : input signal
% w  : filter
%
% output:
%
% y1 : clarinet part
% y2 : non-clarinet part
%
% copyright (C) 2005 Bert Greevenbosch

function [y1, y2]=filterclar(x, w)

  N=length(w);
  lw=N/8;
  hg=7*lw;
  y1=zeros(1, length(x));

  if mod(length(x), N)~=0
    t=mod(length(x), N);
    x=[x, zeros(1, N-t)];
  end

  for n=1:hg-lw:length(x)-N+1
    z=fft(x(n:n+N-1));
    a1=z.*w;
    x1=real(ifft(a1));
    y1(n+lw:n+hg-1)=x1(lw+1:hg);
    disp(sprintf('%1.5f', n/length(x)));
  end

  y2=x-y1;
