% function [y1, y2]=filterpiece(x, N)
%
% filters clarinet from x into y1 and rest into y2
%
% input:
%
% x  : orignal signal
% N  : windowsize
%
% output:
%
% y1 : clarinet signal
% y2 : non-clarinet signal
%
% copyright (C) 2005 Bert Greevenbosch

function [y1, y2]=filterpiece(x, N)

  x=tocolumn(x);

  lw=N/8;
  hg=7*lw;

  y1=zeros(1, length(x));
  y2=y1;
  
  for n=1:hg-lw:length(x)-N+1
    z=fft(x(n:n+N-1));
    q=abs(z);
    q(1)=0;
    [mx, idx]=max(q);
    if(idx>N/2)
      idx=N+2-idx;
    end
    ener=zeros(1, N);
    a1=zeros(1, N);
    a2=z;
    l=1;   
    while(l*idx<N/2+1)
      j1=l*(idx-1)-10+1;
      if(j1<2)
        j1=2;
      end
      j2=l*(idx-1)+10+1;
      if(j2>N/2+1)
        j2=N/2+1;
      end
      for j=j1:j2         
        a1(j)=z(j);
        a2(j)=0;
        a1(N+2-j)=z(N+2-j);
        a2(N+2-j)=0;        
      end
      l=l+1;
    end
    disp(sprintf('%1.4f', n/length(x)));
    x1=real(ifft(a1));
    x2=real(ifft(a2));
    y1(n+lw:n+hg-1)=x1(lw+1:hg);
    y2(n+lw:n+hg-1)=x2(lw+1:hg);
  end
