% function w=harmdat(lfreq, hfreq, N)
%
% creates a filter on the basis of harmonics.
%
% input:
%
% lfreq : lower base frequency
% hfreq : higher base frequency
% N     : size of the filter
%
% output:
%
% w     : filter
%
% copyright (C) 2005 Bert Greevenbosch

function w=harmdat(lfreq, hfreq, N)

  w=zeros(1, N);
  clfreq=lfreq*N/44100;
  chfreq=hfreq*N/44100;
  fq=(clfreq+chfreq)/2
  dfreq=ceil((chfreq-clfreq)/2)
  k=1;
  while fq*k<N/2+1
    fl=floor(fq*k)-dfreq+1;
    fh=ceil(fq*k)+dfreq+1;
    if(fh>N/2)
      fh=N/2;
    end
    if(fl<1)
      fl=1;
    end
    for f=fl:fh
      if(f<N/2+1)
        w(f)=1;
        w(N-f+1)=1;
      end
    end
    k=k+1;
  end
