% function y=notes(x, N, dn)
%
% calculates notes using the discrete Fourier transform (DFT)
% 
% input:
%
% x  : input signal
% N  : size of DFT
% dn : stepsize between succesive measurements
%
% output:
%
% y  : notes played as sines
%
% copyright (C) 2005 Bert Greevenbosch


function y=notes(x, N, dn)

  names=['c__'; 'cis'; 'd__'; 'dis'; 'e__'; 'f__'; 'fis'; 'g__'; 'gis'; 'a__'; 'ais'; 'b__'; 'c__']
  freq =[  131,   139,   147,   156,   165,   175,   185,   196,   208,   220,   233,   247,   262]
  y=zeros(1, length(x));
  maxdif=0;
  phi0=0;

  for n=1:dn:length(x)-N
    fc=detfreq(x(n:n+N-1));
    if fc~=0
      ofc=fc;
      o=3;
      while fc<131
        fc=fc*2;
        o=o-1;
      end
      while fc>262
        fc=fc/2;
        o=o+1;
      end
      mn=abs(fc-freq(1));
      nt=1;
      for j=2:13
        if(abs(fc-freq(j))<mn)
          mn=abs(fc-freq(j));
          nt=j;
        end           
      end
      if nt==13
        o=o+1;
        nt=1;
      end
      fcalc=freq(nt);
      l=o;
      while l>3
        fcalc=fcalc*2;
        l=l-1;
      end
      while l<3
        fcalc=fcalc/2;
        l=l+1;
      end
      if(abs(ofc-fcalc)>maxdif)
        maxdif=abs(ofc-fcalc);
      end
      y(n:n+dn-1)=sin(phi0+2*pi*[0:dn-1]*fcalc/44100)/3;
      phi0=phi0+2*pi*dn*fcalc/44100;
      phi0=mod(phi0, 2*pi);
      disp(sprintf('%s%d', names(nt, :), o));
    else
      y(n:n+dn-1)=sin(phi0)/3;
      disp('rest');
    end
  end

  maxdif
