% function [y1, y2]=trclar(x, N, Z, overlap)
%
% input:
%
% x       : input signal
% N       : window size
% Z       : number of zeros for zero-padding
% overlap : overlap factor
%
% output:
%
% y1      : clarinet signal
% y2      : non-clarinet signal
%
% copyright (C) 2005 Bert Greevenbosch

function [y1, y2]=trvoc(x, N, Z, overlap)

  global fadein;
  global fadeout;
  global tracks;

  x=torow(x);  
  window=sin((0:N-1)*pi/N).^2;
  dn=round((1-overlap)*N);
  nx=N/2+1+dn;
  ny=dn;
  dpsi=(0:(N+Z)/2)*dn*2*pi/(N+Z);    
  [A, phi1]=calcAphi(x(1:N).*window, Z);
  tracks=zeros(N/2+1, 6);
  y1=zeros(1, length(x));
  y2=y1;
  fadein=-.5*cos((0:dn-1)*pi/dn)+.5;
  fadeout=.5*cos((0:dn-1)*pi/dn)+.5;  
  while(nx<length(x)-N/2-dn)      
    [ampl2, dphi, phi2, phases]=trpeak(x(nx-N/2:nx+N/2-1).*window, phi1, dpsi, dn, Z);
    trmatch(dphi, ampl2, phases, N);
    clar=trdetclar(N);
    [y1(ny-dn+1:ny), y2(ny-dn+1:ny)]=trclarreconstruct(clar, N);
    nx=nx+dn; 
    ny=ny+dn;
    phi1=princarg(phi2);
    disp(sprintf('%1.5f; %d lines', nx/length(x), length(phases)));
  end;
  
  mul=max(abs(x))/max(abs(y1+y2));
  y1=y1*mul;
  y2=y2*mul;
