% function clar=trdetclar(N)
%
% marks partials that are part of a clarinet tone
%
% global: tracks
%
% input:
%
% N    : grain size
%
% output:
%
% clar : vector of zeros and ones; clar(k)==1 if the bin k is part of a
%        clarinet tone.
%
% copyright (C) 2005 Bert Greevenbosch

function clar=trdetclar(N);

  global tracks;
  
  clar=zeros(N/2+1, 1);
  [maxamp, idx]=max(tracks(:, 5));
  basefreq=tracks(idx, 4);
  if(basefreq>0)
    freq=basefreq;
    while freq<pi
      bin=floor(N*freq/(2*pi));
      if(bin>1)
        clar(bin-1)=1;
      end
      if(bin>0)
        clar(bin  )=1;
      end
      if(bin<N/2+1)
        clar(bin+1)=1;
      end
      freq=freq+basefreq;
    end
  end
