% function trguidesreconstruct(N)
%
% reconstructs finished lines into the target signals
%
% global: fadein, fadeout, y, lines, xlat, tracks
%
% input:
%
% N : size of the grain used for the measurements
%
% copyright (C) 2005 Bert Greevenbosch

function trguidesreconstruct(N)

  global fadein;
  global fadeout;
  global y;
  global lines;
  global xlat;
  global tracks;
  
  dny=length(fadein);
  for k=1:N/2+1
    if lines(k, 3) & lines(k, 2)>0
      x=0;
      phase=lines(k, 4);
      dphase=lines(k, 5);
      totfreq=dphase;
      A1=lines(k, 6);
      x(1:dny)=(fadein*A1).*cos(phase+(-dny:-1)*dphase);
      for m=1:lines(k, 2)-1
        A0=lines(k, m*2+4);
        A1=lines(k, m*2+6);
        dphase=lines(k, m*2+5);
        totfreq=totfreq+dphase;
        x(m*dny+1:(m+1)*dny)=(fadeout*A0+fadein*A1).*cos(phase+(0:dny-1)*dphase);
        phase=phase+dny*dphase;
      end      
      m=lines(k, 2);
      A0=lines(k, m*2+4);
      dphase=lines(k, m*2+3);
      totfreq=totfreq+dphase;
      totfreq=totfreq/(lines(k, 2)+1);
      x(m*dny+1:(m+1)*dny)=(fadeout*A0).*cos(phase+(0:dny-1)*dphase);
      disp(sprintf('line ended: start %d; length %d; address: %d; average frequency: %1.5f', ...
        lines(k, 1), lines(k, 2), k, totfreq));
      y((lines(k, 1)-1)*dny+1:lines(k, 1)*dny+m*dny)=y((lines(k, 1)-1)*dny+1:lines(k, 1)*dny+m*dny)+x;
      lines(k, 1:3)=zeros(1, 3);
    end    
  end
