% function y=trreconstruct(N)
%
% reconstructs the current partials
%
% global: tracks, fadein, fadeout
%
% input:
%
% N : grain size
%
% output:
%
% y : reconstructed grain
%
% copyright (C) 2005 Bert Greevenbosch

function y=trreconstruct(N)

  global tracks;
  global fadein;
  global fadeout;
  dny=length(fadein);
  y=zeros(1, dny);
  phases=zeros(N/2+1, 1);
  for k=1:N/2+1
     bin=tracks(k, 7);     
     if bin~=0
        if tracks(k, 5)~=0 | tracks(bin, 2)~=0
          A0=tracks(bin, 2);
          A1=tracks(k, 5);
          phi=(0:dny-1)*tracks(k, 4)+tracks(bin, 3);
          y=y+(A0*fadeout+A1*fadein).*cos(phi);
          tracks(bin, 2)=0; % this bin is done
        end        
        phases(k)=dny*tracks(k, 4)+tracks(bin, 3);
     else
        if tracks(k, 5)~=0 % fade in
           A1=tracks(k, 5);
           phi=(-dny:-1)*tracks(k, 4)+tracks(k, 6);
           y=y+A1*fadein.*cos(phi);
           phases(k)=tracks(k, 6); % keep this phase          
        end        
     end
  end
  for k=1:N/2+1
     if tracks(k, 2)~=0 % frequency not done yet; fade out
        A0=tracks(k, 2);        
        phi=(0:dny-1)*tracks(k, 1)+tracks(k, 3);      
        y=y+A0*fadeout.*cos(phi);
     end
  end
  tracks(:, 1:2)=tracks(:, 4:5);  
  tracks(:, 3)=princarg(phases);
  for k=1:N/2+1
    if tracks(k, 5)==0
       tracks(k, 1:3)=zeros(1, 3);
    end
  end